/***
 * gtkMaggot - An improved Tron Game.
 * Copyright (C) 2003      Sylvain Rochet
 * Copyright (C) 2000-2002 Sebastien Bechet & Soazig Bars
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gtk/gtk.h>
#include "game.h"
#include "flash_pictures.h"
#include "flash.h"

GdkPixmap *flashs_p[25];
GdkGC *flashs_gc;

void flash_new(GdkWindow *window) {

	GdkGCValues v;
	int i;

	for (i = 0 ; i < 25 ; i++) {

		flashs_p[i] = gdk_pixmap_create_from_xpm_d(window, NULL, NULL, flashs[i]);
	}

	flashs_gc = gdk_gc_new_with_values(window, &v, 0);
}

void flash_affiche(GdkDrawable *drawable, int x, int y, int num) {

	gdk_draw_pixmap(drawable, flashs_gc, flashs_p[num], 0, 0, x, y, 67, 67);
}


void flash_delete(void) {

	int i; 

	for (i = 0 ; i < 25 ; i++) {

		gdk_pixmap_unref(flashs_p[i]);
	}
}
