/***
 * gtkMaggot - An improved Tron Game.
 * Copyright (C) 2003      Sylvain Rochet
 * Copyright (C) 2000-2002 Sebastien Bechet & Soazig Bars
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "image.h"

#ifndef __ASTICOT_H__
#define __ASTICOT_H__

#define WIDTH 640
#define HEIGHT 480
#define MAXPOINTS 30
#define MAXPLAYERS 6
#define TPAS 3 /* Taille d'un pas en pixel */
#define ITROU 50 /* Taille d'une zone baveuse en pixel */
#define NANGLE 32 /* Nombre d'angles pour faire un 360 */
#define DSCORE 2 /* Delay Score */

#define M_PI           3.14159265358979323846  /* pi */
#define M_PI_2         1.57079632679489661923  /* pi/2 */

#ifndef __IMAGE_H__
typedef struct {

	int x;
	int y;
} doublet;
#endif /* __IMAGE_H__ */


enum clavier { rien, gauche, droit };

typedef struct {

	int score; /* Entre 0 et maxpoints (def MAXPOINTS) */
	int delay_score;
	int angle; /* Entre 0 et NANGLE */
	doublet oldc, coord;
	enum clavier touche;
	guint g, d; /* Nom des touches gauche et droite du joueur */
	gboolean mort;
	int iter; /* Utilis pour savoir quand faire un trou */
	int couleur;
} joueur;

void affiche_ecran(void);

void reset_jeu(gboolean reset_score);
gint boucle_jeu(void);
void affiche_ecran(void);
void free_non_baveux(void);


extern int nb_joueurs;
extern int maxpoints;
extern joueur joueurs[MAXPLAYERS];


#endif /* __ASTICOT_H__ */
