/***
 * gtkMaggot - An improved Tron Game.
 * Copyright (C) 2003      Sylvain Rochet
 * Copyright (C) 2000-2002 Sebastien Bechet & Soazig Bars
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __IMAGE_H__
#define __IMAGE_H__

typedef enum { rouge,  jaune,  violet,  vert,  cyan,  bleu, noir, blanc, 
	       rougef, jaunef, violetf, vertf, cyanf, bleuf } couleurs;

typedef struct {

	int x;
	int y;
} doublet;


extern GdkPixmap *pmap;

GdkColor colors_tab[14];
int pixel2index(guint32 pixel);
void image_putpixel(int x, int y, int couleur);
void image_putpixel_pm(int x, int y, int couleur);
couleurs image_getpixel(int x, int y);
void image_affpixels(GSList *l, int couleur);
void image_reset(void);
gboolean image_new(int largeur, int hauteur);
void image_delete(void);
void ligne_kill(GSList *l);
GSList *ligne(int x1, int y1, int x2, int y2);

#endif /* __IMAGE_H__ */
