/***
 * gtkMaggot - An improved Tron Game.
 * Copyright (C) 2003      Sylvain Rochet
 * Copyright (C) 2000-2002 Sebastien Bechet & Soazig Bars
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <esd.h>
#include "sounds.h"
#include "config.h"

char *sounds_files[] = {
	"doh1.wav",
	"doh2.wav",
	"doh3.wav",
	"doh4.wav",
	"doh5.wav",
	"doh6.wav",
	"background.wav",
	"thread.wav",
	"bounce.wav",
	"start.wav",
	"laugh.wav",
	"wohoo.wav",
	"pause.wav",
	"gameover.wav",
	"button1.wav",
	"button2.wav",
	"button3.wav",
	"button4.wav",
	"load.wav",
	"fail.wav"
};

int sound_esd;
int sound_background;
int sound_thread;
int sound_bounce;
int sound_start;
int sound_laugh;
int sound_wohoo;
int sound_pause;
int sound_gameover;
int sound_morts[6];
int sound_b1;
int sound_b2;
int sound_b3;
int sound_b4;
int sound_load;
int sound_fail;

/*
  <0 erreur, =0 ok
 */
int sound_new(void) {

	char *path;
	int i;

	sound_esd = esd_open_sound(NULL);
	if (sound_esd < 0) return sound_esd;

	for (i = 0 ; i < 6 ; i++) {

		path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[i], NULL);
		sound_morts[i] = esd_file_cache(sound_esd, "gtkMaggot", path);
		g_free(path);
	}

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[6], NULL);
	sound_background = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[7], NULL);
	sound_thread = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[8], NULL);
	sound_bounce = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[9], NULL);
	sound_start = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[10], NULL);
	sound_laugh = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[11], NULL);
	sound_wohoo = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[12], NULL);
	sound_pause = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[13], NULL);
	sound_gameover = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[14], NULL);
	sound_b1 = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[15], NULL);
	sound_b2 = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[16], NULL);
	sound_b3 = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[17], NULL);
	sound_b4 = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[18], NULL);
	sound_load = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	path = g_strconcat(PACKAGE_DATA_DIR, "/", sounds_files[19], NULL);
	sound_fail = esd_file_cache(sound_esd, "gtkMaggot", path);
	g_free(path);

	return TRUE;
}

void sound_play(int num, gboolean loop) {

	if (sound_esd < 0) return;

	loop ? esd_sample_loop(sound_esd, num) : esd_sample_play(sound_esd, num);
}

void sound_stop(int num) {

	if (sound_esd < 0) return;

	esd_sample_stop(sound_esd , num);
}

void sound_delete(void) {

	int i;

	if (sound_esd < 0) return;

	for (i =0 ; i < 6 ; i++) {

		esd_sample_stop(sound_esd, sound_morts[i]);
		esd_sample_free(sound_esd, sound_morts[i]);
	}

	esd_sample_stop(sound_esd, sound_background);
	esd_sample_free(sound_esd, sound_background);

	esd_sample_stop(sound_esd, sound_thread);
	esd_sample_free(sound_esd, sound_thread);

	esd_sample_stop(sound_esd, sound_bounce);
	esd_sample_free(sound_esd, sound_bounce);

	esd_sample_stop(sound_esd, sound_start);
	esd_sample_free(sound_esd, sound_start);

	esd_sample_stop(sound_esd, sound_laugh);
	esd_sample_free(sound_esd, sound_laugh);

	esd_sample_stop(sound_esd, sound_wohoo);
	esd_sample_free(sound_esd, sound_wohoo);

	esd_sample_stop(sound_esd, sound_pause);
	esd_sample_free(sound_esd, sound_pause);

	esd_sample_stop(sound_esd, sound_gameover);
	esd_sample_free(sound_esd, sound_gameover);

	esd_sample_stop(sound_esd, sound_b1);
	esd_sample_free(sound_esd, sound_b1);

	esd_sample_stop(sound_esd, sound_b2);
	esd_sample_free(sound_esd, sound_b2);

	esd_sample_stop(sound_esd, sound_b3);
	esd_sample_free(sound_esd, sound_b3);

	esd_sample_stop(sound_esd, sound_b4);
	esd_sample_free(sound_esd, sound_b4);

	esd_sample_stop(sound_esd, sound_load);
	esd_sample_free(sound_esd, sound_load);

	esd_sample_stop(sound_esd, sound_fail);
	esd_sample_free(sound_esd, sound_fail);

	esd_close(sound_esd);
}
